Attribute VB_Name = "modSubMain"
' modSubMain: Main program chain of execution.

Option Explicit

Public Sub Main()
    initGlobals
    
    Load frmRenderer
    Load frmDisplay
    StartOpenGL frmDisplay.hDC
    'GLSetup False, True, False, True, False, True 'mod true on #1
     
     GLSetup True, True, False, True, False, True
     
    'frmDisplay.mnuHelpRenderer.Enabled = True
    frmDisplay.Show
    
    bAppRunning = True
    While bAppRunning = True
        If ((bPKey = False) Or (bSpaceKey = True)) Then UpdateBall
        HandleKeys
        Redraw
        DoEvents
    Wend
    
    StopOpenGL
    

    Unload frmRenderer
    Set frmRenderer = Nothing
    Unload frmDisplay
    Set frmDisplay = Nothing
    
End Sub
Public Sub HandleKeys()
Dim s1 As Single
Dim s2 As Single, s3 As Single
Dim c1 As Single, c2 As Single
Dim c3 As Single

Dim sx(3) As Single


Dim a As Integer
Dim pi As Integer
pi = 22 / 7

    If bArrowDownKey = True Then dSceneRotation(0) = dSceneRotation(0) - 1
    If bArrowUpKey = True Then dSceneRotation(0) = dSceneRotation(0) + 1
    If bArrowLeftKey = True Then dSceneRotation(1) = dSceneRotation(1) - 1
    If bArrowRightKey = True Then dSceneRotation(1) = dSceneRotation(1) + 1
    If bSpaceKey = False Then shoot_clear = True
    If bSpaceKey = True And shoot_clear = True Then  'shoot missile
    shoot_clear = False
    c3 = 10
     a = alloc_particle
    If a <> -1 Then
        p(a).active = True
        p(a).type = 5
        p(a).X = 0
        p(a).Y = 0
        p(a).z = 80
               
        
        p(a).xv = tx / c3
        p(a).yv = ty / c3
        p(a).zv = (tz - 80) / c3
        
        p(a).col1 = Rnd * (1)
        p(a).col2 = Rnd * (1)
        p(a).col3 = Rnd * (1)
        p(a).col4 = 1
        p(a).life = c3
        p(a).xr = 0
        p(a).yr = 0
        p(a).zr = 0
        p(a).xrv = 1
        p(a).yrv = 1
        p(a).zrv = 0
        p(a).ballradius = 5
    End If
    
    End If
End Sub
Public Sub Redraw()
Dim a As Integer
Dim b As Integer
    glClear clrColorBufferBit + clrDepthBufferBit
    
    glPushMatrix
    
        'gluLookAt 0, 50, 50, 0, 0, 0, 0, 1, 0
        gluLookAt 0, 0, 100, tx, ty, tz, 0, 0, 1
        
        glPushMatrix
            
            glRotatef dSceneRotation(0), 1, 0, 0
            glRotatef dSceneRotation(1), 0, 1, 0
            glRotatef dSceneRotation(2), 0, 0, 1
            
            'glPushMatrix
            '    glTranslatef dBallLocation(0), dBallLocation(1), dBallLocation(2)
            '    glColor4f dBallColor(0), dBallColor(1), dBallColor(2), dBallColor(3)
            '    gluSphere quadSphere, dBallRadius, 16, 16
            'glPopMatrix
            
        Dim r As Single, c As Single
            
        
        Dim cx As Integer, cy As Integer
        Dim x1 As Single, y1 As Single, z1 As Single
        
        
        'Richard Modification : 01
        'glBegin bmPoints
       
        
        
        For cx = 0 To 10
        For cy = 0 To 10
            If city(cx, cy).active = True Then
                'draw building
                'grid size -300 to 300 (ie. 600x600)
                
                
        
            glColor4f 0.8, 0, 0, 0.7
                x1 = (cx * 60) - 300
                y1 = (cy * 60) - 300
                z1 = city(cx, cy).height
                
                
                
                glBegin bmLines
                glVertex3f x1, y1, z1
                glVertex3f x1, y1, 0
                x1 = x1 + 25
                glVertex3f x1, y1, z1
                glVertex3f x1, y1, 0
                y1 = y1 + 25
                glVertex3f x1, y1, z1
                glVertex3f x1, y1, 0
                x1 = x1 - 25
                glVertex3f x1, y1, z1
                glVertex3f x1, y1, 0
                y1 = y1 - 25    'back to origin, now draw tops
                
                'Top
                glVertex3d x1, y1, z1
                glVertex3d x1 + 25, y1, z1
               '
                glVertex3d x1, y1, z1
                glVertex3d x1, y1 + 25, z1
                
                glVertex3d x1 + 25, y1 + 25, z1
                glVertex3d x1, y1 + 25, z1
                
                glVertex3d x1 + 25, y1 + 25, z1
                glVertex3d x1 + 25, y1, z1
                
                'bottom
                glVertex3d x1, y1, 0
                glVertex3d x1 + 25, y1, 0
                
                glVertex3d x1, y1, 0
                glVertex3d x1, y1 + 25, 0
                
                glVertex3d x1 + 25, y1 + 25, 0
                glVertex3d x1, y1 + 25, 0
                
                glVertex3d x1 + 25, y1 + 25, 0
                glVertex3d x1 + 25, y1, 0
                
                
                glEnd
                
                'front
                glColor4f 0, 0, 0.2, 0.5
               
               glPushMatrix
               
                glBegin bmPolygon
                
                    glVertex3f x1, y1, z1
                    glVertex3f x1 + 25, y1, z1
                    glVertex3f x1 + 25, y1 + 25, z1
                   glVertex3f x1, y1 + 25, z1
                glEnd
               
                glBegin bmPolygon
            
                    glVertex3f x1, y1, 0
                    glVertex3f x1 + 25, y1, 0
                    glVertex3f x1 + 25, y1 + 25, 0
                   glVertex3f x1, y1 + 25, 0
               glEnd
             
                glBegin bmPolygon
              
                    glVertex3f x1, y1 + 25, 0
                    glVertex3f x1, y1 + 25, z1
                   glVertex3f x1 + 25, y1 + 25, z1
                   glVertex3f x1 + 25, y1 + 25, 0
                glEnd
             
                glBegin bmPolygon
             
                    glVertex3f x1 + 25, y1 + 25, 0
                    glVertex3f x1 + 25, y1 + 25, z1
                   glVertex3f x1 + 25, y1, z1
                    glVertex3f x1 + 25, y1, 0
               glEnd
                
                glBegin bmPolygon
             
                    glVertex3f x1, y1, 0
                    glVertex3f x1, y1, z1
                   glVertex3f x1 + 25, y1, z1
                   glVertex3f x1 + 25, y1, 0
                glEnd
                
               
               glPopMatrix
               
                
                 
            End If
        Next cy
        Next cx
        glColor4f 0, 0.1, 0, 1
                glBegin bmLines
        For r = -300 To 300 Step 80
            glVertex3f -300, r, -1
            glVertex3f 300, r, -1
        
        Next r
        glEnd
        
        glBegin bmLines
        For r = -300 To 300 Step 80
            glVertex3f r, -300, -1
            glVertex3f r, 300, -1
          
        Next r
                glEnd
                
        glBegin bmLines
        glColor4f 0.8, 0, 0, 0.7
        
    glVertex3f tx - 5, ty, tz
    glVertex3f tx + 5, ty, tz
    glVertex3f tx, ty - 5, tz
    glVertex3f tx, ty + 5, tz
    glVertex3f tx, ty, tz - 5
    glVertex3f tx, ty, tz + 5
    glEnd
        
        'wild static (plenty of juice!)
       'For r = -300 To 300
       ' glVertex3f r, r, r
       ' glVertex3f 0, r / 2, Rnd * (10)
       ' Next r
 
       
        If crosshairs Then
        glBegin bmLines
        
        For r = -300 To 300 Step 20
            glVertex2f 0, r
            glVertex2f 20, r
        Next r
        For r = -300 To 300 Step 20
            glVertex2f r, 0
            glVertex2f r, 20
        Next r
        
               glColor4f 0, 0.5, 0, 0.7
        For r = -300 To 300 Step 20
            glVertex3f -300, r, 300
            glVertex3f 300, r, 300
        Next r
        For r = -300 To 300 Step 20
            glVertex3f r, -300, 300
            glVertex3f r, 300, 300
        Next r
         For r = -300 To 300 Step 20
            glVertex3f -300, r, -300
            glVertex3f 300, r, -300
        Next r
        For r = -300 To 300 Step 20
            glVertex3f r, -300, -300
            glVertex3f r, 300, -300
        Next r
        
         For r = -300 To 300 Step 20
            glVertex3f -300, -300, r
            glVertex3f 300, -300, r
        Next r
        For r = -300 To 300 Step 20
            glVertex3f -300, -300, r
            glVertex3f -300, 300, r
        Next r
        glEnd
        End If
        
        
                
        For a = 0 To plimit
            With p(a)
            
                If .active = True Then
                    If .type = 2 Then
                        'glBegin bmPoints
                        
                        glPushMatrix
                            
                            glTranslatef .X, .Y, .z
                            glRotatef .xr, 1, 0, 0
                            glRotatef .yr, 0, 1, 0
                            glRotatef .zr, 0, 0, 1
                            glColor4f .col1, .col2, .col3, .col4
                            gluSphere quadSphere, .ballradius, 2, 2
                            'glVertex3f .x, .y, .z
                        glPopMatrix
                        'glEnd
                        'For b = 0 To 10
                        'glPushMatrix
                        '    glTranslatef .lastx(b), .lasty(b), .lastz(b)
                        '    glRotatef .lastxr(b), 1, 0, 0
                        '    glRotatef .lastyr(b), 0, 1, 0
                        '    glRotatef .lastzr(b), 0, 0, 1
                        '    glColor4f .col1, .col2, .col3, .lasta(b)
                        '    gluSphere quadSphere, dBallRadius, 2, 2
                        '    'glVertex3f .x, .y, .z
                        'glPopMatrix
                        '
                        'Next b
                        
                    End If
                    
            
                    
                    
                    If .type = 1 Or .type = 5 Then
                    glPushMatrix
                            glTranslatef .X, .Y, .z
                            glRotatef .xr, 1, 0, 0
                            glRotatef .yr, 0, 1, 0
                            glRotatef .zr, 0, 0, 1
                            glColor4f .col1, .col2, .col3, .col4
                            gluSphere quadSphere, .ballradius, 16, 16
                            'glVertex3f .x, .y, .z
                        glPopMatrix
                    End If
                    
                    If .type = 3 Then
                    glPushMatrix
                            glTranslatef .X, .Y, .z
                            glRotatef .xr, 1, 0, 0
                            glRotatef .yr, 0, 1, 0
                            glRotatef .zr, 0, 0, 1
                            glColor4f .col1, .col2, .col3, .col4
                            gluSphere quadSphere, .xv, 16, 16
                            'glVertex3f .x, .y, .z
                        glPopMatrix
                    End If
                    
                    
                End If
            End With
        Next a
    
        
        glPopMatrix
        
    glPopMatrix
    
    SwapBuffers frmDisplay.hDC
End Sub

